package com.madeu.controller.web.webusermedicalchart;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webusermedicalchart.WebUserMedicalChartService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import com.madeu.view.web.WebUserMedicalChartView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebUserMedicalChartController extends ManagerDraftAction{

	@Autowired
	private WebUserMedicalChartService webUserMedicalChartService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 고객 시술차트 정보 리스트 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/selectListUserMedicalChartIntro.do")
	public String  selectListUserMedicalChartIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebUserMedicalChartController  selectListUserMedicalChartIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.selectListUserMedicalChartIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebUserMedicalChartController  selectListUserMedicalChartIntro END");
		return "/web/user/userMedicalChartSelectList";
	}
	
	/**
	 * 고객 시술차트 정보 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/selectListUserMedicalChart.do")
	public ModelAndView selectListUserMedicalChart(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebUserMedicalChartController selectListUserMedicalChart START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.selectListUserMedicalChart(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebUserMedicalChartController selectListUserMedicalChart END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * <b>고객 상세 - 고객 시술차트 정보 리스트 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/downloadUserMedicalChartExcel.do")
	public ModelAndView downloadUserMedicalChartExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebUserMedicalChartController downloadUserMedicalChartExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		List<Map<String, Object>> selectListReport = new ArrayList<Map<String,Object>>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webUserMedicalChartService.selectListUserMedicalChartExcel(paramMap);
				map.put("selectListUserMedicalChart", selectListReport);
				map.put("name", "userMedicalChart");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebUserMedicalChartController downloadUserMedicalChartExcel END");
		return new ModelAndView(new WebUserMedicalChartView(),"map",map);
	}
	
	/**
	 * 고객 시술차트 정보 상세 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/selectUserMedicalChart.do")
	public ModelAndView selectUserMedicalChart(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebUserMedicalChartController selectUserMedicalChart START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.selectUserMedicalChart(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebUserMedicalChartController selectUserMedicalChart END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	/**
	 * 고객 시술차트 정보 상세 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/selectUserMedicalChartList.do")
	public ModelAndView selectUserMedicalChartList(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebUserMedicalChartController selectUserMedicalChartList START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.selectUserMedicalChartList(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebUserMedicalChartController selectUserMedicalChartList END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 고객 시술차트 정보 수정 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/updateUserMedicalChartIntro.do")
	public String  updateUserMedicalChartIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebUserMedicalChartController  updateUserMedicalChartIntro START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.selectListUserMedicalChartIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebUserMedicalChartController  updateUserMedicalChartIntro END");
		return "/web/user/userMedicalChartUpdate";
	}

	/**
	 * 고객 시술차트 정보 수정
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webusermedicalchart/updateUserMedicalChart.do")
	public ModelAndView updateUserMedicalChart(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebUserMedicalChartController updateUserMedicalChart START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webUserMedicalChartService.updateUserMedicalChart(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
			
			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webusermedicalchart/updateUserMedicalChart.do");
				insertMap.put("func", "updateUserMedicalChart");
				insertMap.put("funcName", "고객 시술차트 수정");
				insertMap.put("service", "webUserMedicalChartService");
				insertMap.put("serviceName", "고객 시술차트 수정");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebUserMedicalChartController updateUserMedicalChart END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}
